#!/bin/bash

#########################################################################
# Ersetzen Sie alle Vorkommen von example.com durch ihre eigene Domain! #
#########################################################################

# hexstr: dns-Name in Hex im Format:
# (Laenge) (Byte1) (Byte2) ... (Laenge) (Byte1) .... (00)
# statt Punkten im DNS-Namen die fuehrende Laengenangabe
function hexstr {
  IFS="."
  echo -n "|"
  for n in ${1}; do
    printf "%02x " ${#n}
    echo -n -e "${n}" | hexdump -v -e '/1 "%02X "'
  done
  echo -e "00|"
}

# *.example.com Anfragen müssen immer durchgehen
iptables -I INPUT -p udp --dport 53 -m string --hex-string "$(hexstr example.com)" --to 255 --algo bm -j ACCEPT
iptables -I INPUT -p udp --dport 53 -m string --hex-string "$(hexstr example.com)" --to 255 --algo bm -j LOG --log-prefix "lookup: "

# checkip.dyndns.org; IP-Adresscheck
iptables -I INPUT -p udp --dport 53 -m string --hex-string "$(hexstr checkip.dyndns.org)" --to 255 --algo bm -j ACCEPT
iptables -I INPUT -p udp --dport 53 -m string --hex-string "$(hexstr checkip.dyndns.org)" --to 255 --algo bm -j LOG --log-prefix "checkip: "

# members.dyn.com; Registrierung (neu)
iptables -I INPUT -p udp --dport 53 -m string --hex-string "$(hexstr members.dyn.com)" --to 255 --algo bm -j ACCEPT
iptables -I INPUT -p udp --dport 53 -m string --hex-string "$(hexstr members.dyn.com)" --to 255 --algo bm -m recent --set --name CLIENT
iptables -I INPUT -p udp --dport 53 -m string --hex-string "$(hexstr members.dyn.com)" --to 255 --algo bm -j LOG  --log-prefix "register: "

# members.dyndns.org Registrierung (alt)
# alte Client nehmen nicht members.dyn.com:
# ez-update-3.0.11b8 (aus ipcop)
iptables -I INPUT -p udp --dport 53 -m string --hex-string "$(hexstr members.dyndns.org)" --to 255 --algo bm -j ACCEPT
iptables -I INPUT -p udp --dport 53 -m string --hex-string "$(hexstr members.dyndns.org)" --to 255 --algo bm -m recent --set --name CLIENT
iptables -I INPUT -p udp --dport 53 -m string --hex-string "$(hexstr members.dyndns.org)" --to 255 --algo bm -j LOG  --log-prefix "register: "

# bekannten DNS-Lookups erlauben
iptables -A INPUT -p udp --dport 53 -m recent --rcheck --seconds 86400 --reap --name CLIENT -j ACCEPT

# rest verwerfen
iptables -A INPUT -p udp --dport 53 -j DROP
