PRAGMA foreign_keys=OFF;
BEGIN TRANSACTION;
CREATE TABLE domains (
	id                INTEGER PRIMARY KEY,
	name              VARCHAR(255) NOT NULL COLLATE NOCASE,
	master            VARCHAR(128) DEFAULT NULL,
	last_check        INTEGER DEFAULT NULL,
	type              VARCHAR(6) NOT NULL,
	notified_serial   INTEGER DEFAULT NULL, 
	account           VARCHAR(40) DEFAULT NULL
);
INSERT INTO "domains" VALUES(0,'example.com','',NULL,'MASTER',1,NULL);
CREATE TABLE records (
	id              INTEGER PRIMARY KEY,
	domain_id       INTEGER DEFAULT NULL,
	name            VARCHAR(255) DEFAULT NULL, 
	type            VARCHAR(10) DEFAULT NULL,
	content         VARCHAR(255) DEFAULT NULL,
	ttl             INTEGER DEFAULT NULL,
	prio            INTEGER DEFAULT NULL,
	change_date     INTEGER DEFAULT NULL
, ordername      VARCHAR(255), auth bool);
INSERT INTO "records" VALUES(0,0,'example.com','SOA','example.com. root.example.com. 1 86400 10800 604800 180',180,NULL,NULL,NULL,NULL);
INSERT INTO "records" VALUES(1,0,'example.com','MX','example.com',86400,10,NULL,NULL,NULL);
INSERT INTO "records" VALUES(2,0,'example.com','NS','example.com',86400,NULL,NULL,NULL,NULL);
INSERT INTO "records" VALUES(5,0,'example.com','A','12.34.56.78',86400,NULL,NULL,NULL,NULL);
CREATE TABLE supermasters (
	ip          VARCHAR(25) NOT NULL, 
	nameserver  VARCHAR(255) NOT NULL COLLATE NOCASE, 
	account     VARCHAR(40) DEFAULT NULL
);
CREATE TABLE domainmetadata (
 id              INTEGER PRIMARY KEY,
 domain_id       INT NOT NULL,
 kind            VARCHAR(16) COLLATE NOCASE,
 content        TEXT
);
CREATE TABLE cryptokeys (
 id             INTEGER PRIMARY KEY,
 domain_id      INT DEFAULT NULL,
 flags          INT NOT NULL,
 active         BOOL,
 content        TEXT
);
CREATE TABLE tsigkeys (
 id             INTEGER PRIMARY KEY,
 name           VARCHAR(255) COLLATE NOCASE,
 algorithm      VARCHAR(255) COLLATE NOCASE,
 secret         VARCHAR(255)
);
CREATE TABLE users (
 id             VARCHAR(255) PRIMARY KEY,
 password       VARCHAR(255) NOT NULL
);
CREATE TABLE hostnames (
 hostname       VARCHAR(255) PRIMARY KEY,
 userid         VARCHAR(255) NOT NULL
);
CREATE UNIQUE INDEX name_index ON domains(name);
CREATE INDEX rec_name_index ON records(name);
CREATE INDEX nametype_index ON records(name,type);
CREATE INDEX domain_id ON records(domain_id);
CREATE INDEX orderindex on records(ordername);
CREATE UNIQUE INDEX namealgoindex on tsigkeys(name, algorithm);
CREATE UNIQUE INDEX user_index ON users(id);
CREATE UNIQUE INDEX hostname_index ON hostnames(hostname);
COMMIT;
